%        
%   ()  R(t)=exp{-|t/tau|}, 
%  tau -  .

%     
close all
%    (WORKSPACE)
clear

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                       %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% T -   , 
T=1;
% tau -   , 
tau=0.20;
% N -      
N=1024;
% K -    
K=40;

% dt -    
dt=T/N;
% df -    
df=1/(N*dt);
% t -      
t=(0:dt:T-dt)';
% f -   ,       
f=(-0.5/dt:df:0.5/dt-df)';
% R -      
R=exp(-abs(t(1:N/2+1)/tau));
R=[R; conj(R(N/2:-1:2))]; 
% Sp -     
Sp=abs(ifft(R));
R=[R(N/2:N); R(1:N/2)];
% Re - ,        
Re=zeros(size(R));

%     
figure(1)
plot(f,fftshift(Sp))
title('  ')
xlabel('f, ')
ylabel('S(f)')
grid

% Nidle -        
%              (  )
Nidle=round(3*tau/dt);
% W -    
W=1/tau;
% a, b -   
a=(1-0.5*W*dt)/(1+0.5*W*dt);
b=sqrt(0.5*W)*dt/(1+0.5*W*dt);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                            %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for k=1:K
   % x -      ( )
   x=randn(N+Nidle,1)/sqrt(dt);
   % y1 -     
   y1=0;
   %    
   for n=2:Nidle
      y1=a*y1+b*(x(n)+x(n-1));
   end;
   %    
   y(1,1)=y1; %   
   for n=2:N
      %   
      y(n,1)=a*y(n-1)+b*(x(Nidle+n)+x(Nidle+n-1));
   end;

%   k-   
figure(2)
plot(t,real(y));
title(['  , k=' int2str(k)])
xlabel('t, ')
ylabel('s(t)')
grid
pause(1)

%      
% Ree -    k-   
Ree=xcorr(y,y,N/2,'unbiased');
%      
Re=Re+Ree;
end

%     
Re=Re./K;
% R       
R=[R Re];

%   : 
% -  ,  
% -  ,  
figure(3)
plot([t;T]-0.5*T,real(R))
title(' :    ')
xlabel('\tau, c')
ylabel('R(\tau)')
grid
